/*###############################################################################
# Linux Management Providers (LMP), EthernetPort provider package
# Copyright (C) 2008 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_ETHERNETPORTDEVICESAPIMPLEMENTATIONACCESS_H_
#define OPENDRIM_ETHERNETPORTDEVICESAPIMPLEMENTATIONACCESS_H_

#include "EthernetPort_Common.h"

#include "OpenDRIM_EthernetPortDeviceSAPImplementation.h"
#include "assocOpenDRIM_EthernetPortDeviceSAPImplementation.h"

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_load(const CMPIBroker* broker, string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_unload(string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_EthernetPortDeviceSAPImplementation>& instances, const char** properties, string& errorMessage, const string& discriminant);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_EthernetPortDeviceSAPImplementation& instance, const char** properties, string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EthernetPortDeviceSAPImplementation& newInstance, const OpenDRIM_EthernetPortDeviceSAPImplementation& oldInstance, const char** properties, string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EthernetPortDeviceSAPImplementation& instance, string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_EthernetPortDeviceSAPImplementation& instance, string& errorMessage);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_associatorAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const char** properties, vector<Instance>& Dependent_associatedInstances, string& errorMessage, const string& discriminant);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_associatorDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const char** properties, vector<Instance>& Antecedent_associatedInstances, string& errorMessage, const string& discriminant);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_referenceAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const vector<Instance>& Dependent_instances, vector<OpenDRIM_EthernetPortDeviceSAPImplementation>& OpenDRIM_EthernetPortDeviceSAPImplementation_instances, const char** properties, string& errorMessage, const string& discriminant);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_referenceDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const vector<Instance>& Antecedent_instances, vector<OpenDRIM_EthernetPortDeviceSAPImplementation>& OpenDRIM_EthernetPortDeviceSAPImplementation_instances, const char** properties, string& errorMessage, const string& discriminant);

int EthernetPort_OpenDRIM_EthernetPortDeviceSAPImplementation_populate(OpenDRIM_EthernetPortDeviceSAPImplementation& instance, string& errorMessage);

#endif /*OPENDRIM_ETHERNETPORTDEVICESAPIMPLEMENTATIONACCESS_H_*/
